Pixlr.FileSave = {
	SaveAs : function(data)
	{
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
		fp.init(window, "Save As", Components.interfaces.nsIFilePicker.modeSave);
		fp.defaultString = Pixlr.GetFileName();
		fp.appendFilter("PNG", "*.png");
		
		var result = fp.show();
		if(result == fp.returnOK || result == fp.returnReplace)
		{
			var file = fp.file;
			var path = file.path;
			var type = "image/png";

			if (path.substr(path.lastIndexOf(".")).toLowerCase() != ".png") {
				path += ".png";
			}
			file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath(path);
			
			Pixlr.FileSave.Save(data, file, type);
		}
	},
	Save : function(data, file, mimeType)
	{
		var io = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var source = io.newURI(data, "UTF8", null);
		var target = io.newFileURI(file);

		var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);

		persist.persistFlags = Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
		persist.persistFlags |= Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;

		var xfer = Components.classes["@mozilla.org/transfer;1"].createInstance(Components.interfaces.nsITransfer);
		xfer.init(source, target, "", null, null, null, persist);
		persist.progressListener = xfer;

		persist.saveURI(source, null, null, null, null, file);
	}
}