Pixlr.Menu = {
	OnLoad:function()
	{
		var e = document.getElementById("contentAreaContextMenu")
		if(e) e.addEventListener("popupshowing", function(ev){ Pixlr.Menu.ContextMenuShowing(ev); }, false);
	},
	ContextMenuShowing: function(event)
	{
		if (gContextMenu)
		{
			this.imageURL = '';
			this.backgroundURL = '';
			
			var edit = document.getElementById("pixlr-ctx-edit-image");
			if(edit)
			{
				edit.hidden = (!gContextMenu.onImage || !Pixlr.prefs.getBoolPref("menuForImages"));
				if(gContextMenu.onImage) this.imageURL = gContextMenu.imageURL;
			}

			edit = document.getElementById("pixlr-ctx-edit-background");
			if(edit)
			{
				edit.hidden = (!gContextMenu.hasBGImage || !Pixlr.prefs.getBoolPref("menuForBackgrounds"));
				if(gContextMenu.hasBGImage) this.backgroundURL = gContextMenu.bgImageURL;
			}
			edit = document.getElementById("pixlr-ctx-edit-screencapture");
			if(edit) edit.hidden = !Pixlr.prefs.getBoolPref("menuForBackgrounds");
		}
	},
	EditImage: function(bg)
	{
		var editor = (Pixlr.prefs.getIntPref("editorToOpen") == 0) ? "editor":"express";
		var url = "http://www.pixlr.com/"+ editor +"/?fetc=her&image="+ escape((bg)?this.backgroundURL:this.imageURL);
		Pixlr.OpenIn(url);
	}
};
window.addEventListener("load", Pixlr.Menu.OnLoad, false);
